//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "dxsoftex.h"
#include "IniFiles.hpp"
#include "conio.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SHDocVw_OCX"
#pragma resource "*.dfm"
USELIB("dxsoftex.lib");
TForm1 *Form1;

TIniFile *Ini = new TIniFile("hamlog2.ini");

AnsiString Ver_HamLog="HamLog/UA1CBM/ ver.2.0.alpha, build 28.03.2005";


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
Form1->Caption=Ver_HamLog;
}
//---------------------------------------------------------------------------

//****** Web cluster monitor
#include "Unit1_DX_Cluster.inc"

//---------------------------------------------------------------------------


void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
Word Year, Month, Day, Hour, Min, Sec, MSec;
Word ShiftHour, SetHour;
Char SH[255];

TDateTime MyDate = Now();

strcpy(SH, ComboBox3->Text.c_str());
ShiftHour = atof(SH);

DecodeTime(MyDate,Hour,Min,Sec,MSec);

//-------------------------------------------------------------
//   
if (RadioButton1->Checked)
{
  if (Hour+ShiftHour>23)
  {
   SetHour=Hour+ShiftHour-24;
   Edit13->Text=AnsiString(MyDate.CurrentDate()+1);
  }
  else
  {
   SetHour=Hour+ShiftHour;
   Edit13->Text=AnsiString(MyDate.CurrentDate());
  }
}
//-------------------------------------------------------------
//   
if (RadioButton2->Checked)
{
  if (Hour-ShiftHour<0)
  {
   SetHour=24+Hour-ShiftHour;
   Edit13->Text=AnsiString(MyDate.CurrentDate()-1);
  }
  else
  {
   SetHour=Hour-ShiftHour;
   Edit13->Text=AnsiString(MyDate.CurrentDate());
  }
}
//-------------------------------------------------------------
Edit14->Text=AnsiString(SetHour)+":"+AnsiString(Min)+":"+AnsiString(Sec);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Nextfield1Click(TObject *Sender)
{
//===============  QSO =========================
if (Edit15->Text!="")
{
Table1->Edit();
Table1->Append();
Table1->FieldValues["DATE"]=Edit13->Text;
Table1->FieldValues["TIME"]=Edit14->Text;
Table1->FieldValues["BAND"]=ComboBox_Band->Text;
Table1->FieldValues["CALL"]=Edit15->Text;
Table1->FieldValues["R_RST"]=Edit17->Text;
if (CheckBox1->Checked) // MODE  T_RST  
    Table1->FieldValues["T_RST"]=Edit18->Text+" "+ComboBox_Mode->Text;
    else Table1->FieldValues["T_RST"]=Edit18->Text;

Table1->FieldValues["TEXT"]=Edit16->Text;

Edit15->Text="";  //   CALL
Edit15->SetFocus();//     CALL

//************         
char Eng[78]="ABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLMNOPQRSTUVWXYZ";
char Rus[78]="abcdefghijklmnopqrstuvwxyz";
char Txt[14];
AnsiString TempTxt;
TempTxt=Table1->Fields->Fields[3]->AsString; //Fields[3] -  CALL

//StatusBar1->SimpleText=AnsiString(StrLen(TempTxt.c_str()));

if (StrLen(TempTxt.c_str())>0)
 {
  //TempTxt=AnsiString(Table1->FieldValues["CALL"]);
  strcpy( Txt, TempTxt.c_str() );
  for (int i=0; i<13;i++)
   {
    for (int q=0; q<78; q++)
     {
      if (Txt[i]==Rus[q]) Txt[i]=Eng[q];
     }
   }
  Table1->Edit();
  Table1->FieldValues["CALL"]=Txt;
  Table1->CheckBrowseMode();
 }
//***************************************************
}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit15Change(TObject *Sender)
{
//  QSO
Table2->Filter="CALL='"+Edit15->Text+"*'";
Table2->Filtered=true;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox_ModeChange(TObject *Sender)
{
Edit17->Text="59";
Edit18->Text="59";
//     

if (ComboBox_Mode->Text=="CW")
 {
  Edit17->Text="599";
  Edit18->Text="599";
 }
if (ComboBox_Mode->Text=="PSK31")
 {
  Edit17->Text="599";
  Edit18->Text="599";
 }
if (ComboBox_Mode->Text=="RTTY")
 {
  Edit17->Text="599";
  Edit18->Text="599";
 }
if (ComboBox_Mode->Text=="SSTV")
 {
  Edit17->Text="599";
  Edit18->Text="599";
 }


}
//---------------------------------------------------------------------------


void __fastcall TForm1::SaveSetupClick(TObject *Sender)
{
//***** Save CW_Messages Section ************
Ini->WriteString("CW_Messages","Edit_CW_F1",Edit_CW_F1->Text);
Ini->WriteString("CW_Messages","Edit_CW_F2",Edit_CW_F2->Text);
Ini->WriteString("CW_Messages","Edit_CW_F3",Edit_CW_F3->Text);
Ini->WriteString("CW_Messages","Edit_CW_F4",Edit_CW_F4->Text);
Ini->WriteString("CW_Messages","Edit_CW_F5",Edit_CW_F5->Text);
Ini->WriteString("CW_Messages","Edit_CW_F6",Edit_CW_F6->Text);
Ini->WriteString("CW_Messages","Edit_CW_F7",Edit_CW_F7->Text);
Ini->WriteString("CW_Messages","Edit_CW_F8",Edit_CW_F8->Text);

//***** Save Time Shift Sectiom ************
Ini->WriteString("Time_Shift","Hours",ComboBox3->Text);

if (RadioButton1->Checked)
Ini->WriteString("Time_Shift","Shift","Up");
else
Ini->WriteString("Time_Shift","Shift","Down");

//******* Save MainLog Section *****************
Ini->WriteString("MainLog","ComboBox_Band",ComboBox_Band->Text);
Ini->WriteString("MainLog","ComboBox_Mode",ComboBox_Mode->Text);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::LoadSetupClick(TObject *Sender)
{
//***** Load CW_Messages Section ************
Edit_CW_F1->Text=Ini->ReadString("CW_Messages","Edit_CW_F1","~[tx] CQ CQ CQ DE UA1CBM UA1CBM UA1CBM PSE K[~rx]");
Edit_CW_F2->Text=Ini->ReadString("CW_Messages","Edit_CW_F2","~[tx] DE UA1CBM [~rx]");
Edit_CW_F3->Text=Ini->ReadString("CW_Messages","Edit_CW_F3","~[tx] ~[rx]");
Edit_CW_F4->Text=Ini->ReadString("CW_Messages","Edit_CW_F4","~[tx] ~[rx]");
Edit_CW_F5->Text=Ini->ReadString("CW_Messages","Edit_CW_F5","~[tx] ~[rx]");
Edit_CW_F6->Text=Ini->ReadString("CW_Messages","Edit_CW_F6","~[tx] ~[rx]");
Edit_CW_F7->Text=Ini->ReadString("CW_Messages","Edit_CW_F7","~[tx] ~[rx]");
Edit_CW_F8->Text=Ini->ReadString("CW_Messages","Edit_CW_F8","~[tx] QRZ ?~[rx]");

//***** Load Time Shift Sectiom ************
ComboBox3->Text=Ini->ReadString("Time_Shift","Hours","3");

if (Ini->ReadString("Time_Shift","Shift","Up")=="Up")
RadioButton1->Checked=true;
else
RadioButton2->Checked=true;

//******* Load MainLog Section *****************
ComboBox_Band->Text=Ini->ReadString("MainLog","ComboBox_Band","14");
ComboBox_Mode->Text=Ini->ReadString("MainLog","ComboBox_Mode","CW");

}
//---------------------------------------------------------------------------

//******   CWTYPE **************

//******** F1...F8  CW messages
void __fastcall TForm1::F1_CWClick(TObject *Sender)
{
// -= F1 =-
DxsoftExchangeInit(1);
char send_cw[255];
AnsiString send_cw_ansi=Edit_CW_F1->Text;
         strcpy(send_cw, send_cw_ansi.c_str());

 for (int i = 0; i < send_cw_ansi.Length(); i++)
DxsoftPutSymToTxBuffer(send_cw[i]);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::F2_CWClick(TObject *Sender)
{
// -= F2 =-
DxsoftExchangeInit(1);
char send_cw[255];
AnsiString send_cw_ansi=Edit_CW_F2->Text;
         strcpy(send_cw, send_cw_ansi.c_str());

 for (int i = 0; i < send_cw_ansi.Length(); i++)
DxsoftPutSymToTxBuffer(send_cw[i]);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::F3_CWClick(TObject *Sender)
{
// -= F3 =-
DxsoftExchangeInit(1);
char send_cw[255];
AnsiString send_cw_ansi=Edit_CW_F3->Text;
         strcpy(send_cw, send_cw_ansi.c_str());

 for (int i = 0; i < send_cw_ansi.Length(); i++)
DxsoftPutSymToTxBuffer(send_cw[i]);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::F4_CWClick(TObject *Sender)
{
// -= F4 =-
DxsoftExchangeInit(1);
char send_cw[255];
AnsiString send_cw_ansi=Edit_CW_F4->Text;
         strcpy(send_cw, send_cw_ansi.c_str());

 for (int i = 0; i < send_cw_ansi.Length(); i++)
DxsoftPutSymToTxBuffer(send_cw[i]);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::F5_CWClick(TObject *Sender)
{
// -= F5 =-
DxsoftExchangeInit(1);
char send_cw[255];
AnsiString send_cw_ansi=Edit_CW_F5->Text;
         strcpy(send_cw, send_cw_ansi.c_str());

 for (int i = 0; i < send_cw_ansi.Length(); i++)
DxsoftPutSymToTxBuffer(send_cw[i]);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::F6_CWClick(TObject *Sender)
{
// -= F6 =-
DxsoftExchangeInit(1);
char send_cw[255];
AnsiString send_cw_ansi=Edit_CW_F6->Text;
         strcpy(send_cw, send_cw_ansi.c_str());

 for (int i = 0; i < send_cw_ansi.Length(); i++)
DxsoftPutSymToTxBuffer(send_cw[i]);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::F7_CWClick(TObject *Sender)
{
// -= F7 =-
DxsoftExchangeInit(1);
char send_cw[255];
AnsiString send_cw_ansi=Edit_CW_F7->Text;
         strcpy(send_cw, send_cw_ansi.c_str());

 for (int i = 0; i < send_cw_ansi.Length(); i++)
DxsoftPutSymToTxBuffer(send_cw[i]);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::F8_CWClick(TObject *Sender)
{
// -= F8 =-
DxsoftExchangeInit(1);
char send_cw[255];
AnsiString send_cw_ansi=Edit_CW_F8->Text;
         strcpy(send_cw, send_cw_ansi.c_str());

 for (int i = 0; i < send_cw_ansi.Length(); i++)
DxsoftPutSymToTxBuffer(send_cw[i]);

}
//---------------------------------------------------------------------------



void __fastcall TForm1::Edit_CW_WindowChange(TObject *Sender)
{
DxsoftExchangeInit(1);
char send_cw[255];
AnsiString send_cw_ansi=Edit_CW_Window->Text;
         strcpy(send_cw, send_cw_ansi.c_str());

 for (int i = 0; i < send_cw_ansi.Length(); i++)
  DxsoftPutSymToTxBuffer(send_cw[i]);
Edit_CW_Window->Text="";
  }
//---------------------------------------------------------------------------

void __fastcall TForm1::TXRX1Click(TObject *Sender)
{
//Switch RX/TX in CWTYpe
//   HOME  ~[tx]
//      CW ...
//    ~[rx]
//      QTH  

DxsoftExchangeInit(1);
char send_cw[255];

if (Button_TX_RX->Caption=="TX_OFF")
 {
  Edit_CW_Window->SetFocus();
  strcpy(send_cw,"~[tx]");
  for (int i = 0; i < 5; i++)  DxsoftPutSymToTxBuffer(send_cw[i]);
  Button_TX_RX->Caption="TX_ON";

 }
else
 {
 strcpy(send_cw,"~[rx]");
  for (int i = 0; i < 5; i++)  DxsoftPutSymToTxBuffer(send_cw[i]);
  Button_TX_RX->Caption="TX_OFF";
  Edit16->SetFocus();
 }
}
//---------------------------------------------------------------------------

